aboutsummaryrefslogtreecommitdiffstats
path: root/resources/libraries/bash/entry/check_crc.sh
diff options
context:
space:
mode:
authorVratko Polak <vrpolak@cisco.com>2019-07-30 10:40:50 +0200
committerVratko Polak <vrpolak@cisco.com>2019-07-31 08:00:05 +0000
commit29726f92698452f51033fc3ab52f112b74eae594 (patch)
tree7436f9dcd944c2f2b9c45fd0fb37d4ff96b6ce7a /resources/libraries/bash/entry/check_crc.sh
parentf966718dfe763e48f2cc89e9ede2408a0f782d1b (diff)
Add VPP API CRC checking
+ Include both checking at runtime and standalone static quick check. + Runtime checking does not look for missing messages, as messages belonging to disabled plugins are not visible. + Standalone check script has nice loud output. Change-Id: I1dfc3846d1bcdad0b09017d4ce8edd5028e17e0c Signed-off-by: Vratko Polak <vrpolak@cisco.com>
Diffstat (limited to 'resources/libraries/bash/entry/check_crc.sh')
-rw-r--r--resources/libraries/bash/entry/check_crc.sh45
1 files changed, 45 insertions, 0 deletions
diff --git a/resources/libraries/bash/entry/check_crc.sh b/resources/libraries/bash/entry/check_crc.sh
new file mode 100644
index 0000000000..6c91d28a34
--- /dev/null
+++ b/resources/libraries/bash/entry/check_crc.sh
@@ -0,0 +1,45 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2019 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -exuo pipefail
+
+# This entry script does not change CSIT branch,
+# use "with_oper_for_vpp.sh" wrapper for that.
+#
+# Assumptions:
+# + There is a directory holding VPP repo with patch under test checked out.
+# + It contains csit subdirectory with CSIT code to use (this script is there).
+# + Everything needed to generate .api.json files is already installed locally.
+# Consequences:
+# + At the end, VPP repo has parent commit checked out and built.
+# + Directories build_root, build and csit are reset during the run.
+# + The following directory (relative to VPP repo) is (re)created:
+# ++ build-root/install-vpp-native/vpp/share/vpp/api
+
+# "set -eu" handles failures from the following two lines.
+BASH_ENTRY_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
+BASH_FUNCTION_DIR="$(readlink -e "${BASH_ENTRY_DIR}/../function")"
+source "${BASH_FUNCTION_DIR}/common.sh" || {
+ echo "Source failed." >&2
+ exit 1
+}
+source "${BASH_FUNCTION_DIR}/per_patch.sh" || die "Source failed."
+common_dirs || die
+set_perpatch_vpp_dir || die
+activate_virtualenv "${VPP_DIR}" || die
+# TODO: Create bash functions for the following one-liners?
+make json-api-files || die "Generation of .api.json files failed."
+python csit/resources/tools/integrated/check_crc.py
+# RuntimeError causes nonzero return code, to vote -1.